"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var redux_1 = require("redux");
var ReduxClass_decorator_1 = require("./ReduxClass.decorator");
function combineReduxClassReducers(reducers) {
    var wrappedReducers = tslib_1.__assign({}, reducers);
    for (var reducerKey in reducers) {
        if (reducers.hasOwnProperty(reducerKey)) {
            var reducer = reducers[reducerKey];
            wrappedReducers[reducerKey] = ReduxClass_decorator_1.ReduxClassWrapper(reducer);
        }
    }
    return redux_1.combineReducers(wrappedReducers);
}
exports.combineReduxClassReducers = combineReduxClassReducers;
//# sourceMappingURL=combineReduxClassReducers.js.map